<template>
  <div>
    <el-dialog
      :title="title"
      :close-on-click-modal="false"
	  draggable
      width="1500px"
      @close="close"
      @keyup.enter.native="doSubmit"
      v-model="visible">
      <el-form :model="inputForm" ref="inputForm" v-loading="loading" :class="method==='view'?'readonly':''"  :disabled="method==='view'"
               label-width="100px" @submit.native.prevent>

        <el-divider content-position="left"><i class="el-icon-document"></i> 基础信息</el-divider>
        <el-row :gutter="26">
          <el-col :span="12">
            <el-form-item label="入库编号" prop="wareHouseNumber">
              <el-input placeholder="自动生成" v-model="inputForm.wareHouseNumber" :disabled="true"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="入库名称" prop="wareHouseName"
                          :rules="[{required: true, message: '入库名称不能为空', trigger: 'blur'}
                 ]">
              <el-input v-model="inputForm.wareHouseName" placeholder="请填写入库名称"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="经办人" prop="handledBy">
              <el-input v-model="inputForm.handledBy" :disabled="true"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="经办人部门" prop="handledByOffice">
              <SelectTree
                :disabled="true"
                ref="officeTree"
                :props="{
                  value: 'id',             // ID字段名
                  label: 'name',         // 显示名称
                  children: 'children'    // 子级字段名
                }"

                :url="`/system-server/sys/office/treeData?type=2`"
                :value="inputForm.handledByOffice"
                :accordion="true"
                size="default"
                @getValue="(value) => {inputForm.handledByOffice=value}"/>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="入库时间" prop="wareHouseDate" :rules="[{required: true, message:'请选择入库时间', trigger:'blur'}]">
              <el-date-picker
                v-model="inputForm.wareHouseDate"
                type="date"
                placement="bottom-start"
                value-format="YYYY-MM-DD"
                style="width: 100%"
                placeholder="选择日期">
              </el-date-picker>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="采购编号" prop="purchaseNo"
                          :rules="[]">
              <el-input :readonly="true" @focus="openContractForm()" v-model="inputForm.purchaseNo" placeholder="请选择采购编号">
                <el-button slot="append" icon="el-icon-search" @click="openContractForm()"></el-button>
              </el-input>
            </el-form-item>
          </el-col>
          <el-col :span="24">
            <el-form-item label="备注" prop="remarks">
              <el-input v-model="inputForm.remarks"
                        type="textarea"
                        :rows="5"
                        maxlength="500"
                        placeholder="请输入简介"
                        show-word-limit>
              </el-input>
            </el-form-item>
          </el-col>
        </el-row>
        <div v-if="commonJS.isNotEmpty(inputForm.purchaseNo)">
          <el-divider content-position="left" ><i class="el-icon-document" style="font-weight: bold;font-size: 16px;color:#409EFF"></i>
            <el-link @click="viewContract(inputForm.purchaseNo)"><span style="font-weight: bold;font-size: 16px;color:#409EFF">&nbsp;采购详情</span></el-link>
          </el-divider>
          <el-row  :gutter="15" >
            <el-col :span="24">
				<vxe-table
					border
					show-footer
					show-overflow
					:footer-method="footerMethod"
					ref="detailTable"
					class="vxe-table-element"
					:data="inputForm.detailInfos"
					style="margin-left: 3em"
				>
					<vxe-column min-width="100" align="center" field="purchaserAgent" title="采购人" ></vxe-column>
					<vxe-column min-width="100" align="center" field="procurementOffice" title="采购部门" ></vxe-column>
					<vxe-column min-width="100" align="center" field="procurementType" title="采购类型" ></vxe-column>
					<vxe-column min-width="100" align="center" field="supplierName" title="供应商" ></vxe-column>
					<vxe-column min-width="220" align="center" field="tradeName"  title="商品名称" ></vxe-column>
					<vxe-column min-width="100" align="center" field="tradePrice" title="商品单价(元)" ></vxe-column>
					<vxe-column min-width="80" align="center" field="tradeNumber" title="商品数量" ></vxe-column>
					<vxe-column min-width="100" align="center" field="priceSum" title="商品总价" ></vxe-column>
					<vxe-column min-width="100" align="center" field="company" title="单位" ></vxe-column>
					<vxe-column min-width="100" align="center" field="remarks" title="备注" ></vxe-column>
					<vxe-column align="center" title="操作" fixed="right" width="150">
						<template v-slot="scope">
							<vxe-button size="small" v-if="method === 'purchaseAdd'" status="primary" :disabled="false" @click="wareHouseAdd(scope.$rowIndex)">入库</vxe-button>
							<vxe-button size="small" status="primary" :disabled="false" @click="seeFileInfo(scope.$rowIndex)">附件</vxe-button>
						</template>
					</vxe-column>
				</vxe-table>
			</el-col>
          </el-row>
        </div>

        <el-divider content-position="left"><i class="el-icon-document"></i>
          入库详情
          <el-button style="margin-left: 20px" type="primary" @click="insertEvent('detail')" plain>
            新增
          </el-button>
        </el-divider>
        <el-row  :gutter="15">
          <el-col :span="24">
			  <vxe-table
				  border
				  show-footer
				  show-overflow
				  :footer-method="footerMethod2"
				  ref="detailTableWare"
				  class="vxe-table-element"
				  :data="inputForm.wareHouse"
				  style="margin-left: 3em"
				  highlight-current-row
				  :edit-config="{trigger: 'click', mode: 'row', showStatus: false, autoClear: true, icon: '-'}"
				  :edit-rules="validRules"
				  :key="tableKey"
			  >
				  <vxe-table-column min-width="100px" align="center" field="wareHouseMan" title="入库人" :edit-render="{}">
					  <template v-slot:edit="scope">
						  <el-input v-model="scope.row.wareHouseMan" @focus="userPullListForm(scope.$rowIndex)"></el-input>
					  </template>
				  </vxe-table-column>
				  <vxe-table-column min-width="100px" align="center" field="wareHouseManOffice" title="入库部门" :edit-render="{}">
					  <template v-slot:edit="scope">
						  <el-input :disabled='true' v-model="scope.row.wareHouseManOffice" ></el-input>
					  </template>
				  </vxe-table-column>
				  <vxe-table-column min-width="100px" align="center" field="wareHouseType" title="入库类型" :edit-render="{}" >
					  <template v-slot:edit="scope">
						  <el-input v-model="scope.row.wareHouseType" @focus="typePullForm(scope.$rowIndex)"></el-input>
					  </template>
				  </vxe-table-column>
				  <vxe-table-column min-width="180px" align="center" field="tradeName" title="商品名称" :edit-render="{}">
					  <template v-slot:edit="scope">
						  <vxe-pulldown ref="xDown1" transfer>
							  <template #default>
								  <vxe-input v-model="scope.row.tradeName" placeholder="请输入商品名称" maxlength="64"
											 @focus="focusEvent1(scope.row)"
											 @input="keyupEvent1(scope.row)"></vxe-input>
							  </template>
							  <template #dropdown>
								  <div class="my-dropdown1">
									  <div class="list-item1" v-for="item in scope.row.tradeNameData" :key="item.id" @click="selectEvent1(scope.row, item)">
										  <span>{{ item.tradeName }}</span>
									  </div>
								  </div>
							  </template>
						  </vxe-pulldown>
					  </template>
				  </vxe-table-column>
				  <vxe-table-column min-width="100px" align="center" field="supplierName" title="供应商" :edit-render="{}">
					  <template v-slot:edit="scope">
						  <vxe-pulldown ref="xDown4" transfer>
							  <template #default>
								  <vxe-input v-model="scope.row.supplierName" :readonly="true" :disabled="method === 'view'"
											 placeholder="请填写供应商" @focus="focusEvent4(scope.$rowIndex)" ></vxe-input>
							  </template>
							  <template #dropdown>
								  <div style="width: 600px;
                              height: 300px;
                              background-color: #fff;
                              box-shadow: 0 0 6px 2px rgba(0, 0, 0, 0.1);">
									  <vxe-input v-model="suppName" type="search" @search-click="searchClick"  placeholder="请输入供应商名称搜索" style="width: 100%" clearable></vxe-input>
									  <vxe-grid
										  border
										  show-overflow
										  auto-resize
										  height="auto"
										  :row-config="{isHover: true}"
										  :loading="loading4"
										  :pager-config="tablePage4"
										  :data="tableData4"
										  :columns="tableColumn4"
										  @cell-click="cellClickEvent4"
										  @page-change="pageChangeEvent4">
									  </vxe-grid>
								  </div>
							  </template>
						  </vxe-pulldown>
					  </template>
				  </vxe-table-column>
				  <vxe-table-column min-width="80px" align="center" field="tradeNumber" title="商品数量" :edit-render="{}">
					  <template v-slot:edit="scope">
						  <el-input @change="changeValue2" v-model="scope.row.tradeNumber" @blur="scope.row.tradeNumber = twoDecimalPlaces2(scope.row.tradeNumber)" maxlength="10"></el-input>
					  </template>
				  </vxe-table-column>
				  <vxe-table-column min-width="80px" align="center" field="company" title="单位" :edit-render="{}">
					  <template v-slot:edit="scope">
						  <el-input maxlength="64" v-model="scope.row.company"></el-input>
					  </template>
				  </vxe-table-column>
				  <vxe-table-column min-width="80px" align="center" field="tradePrice" title="商品单价(元)" :edit-render="{}">
					  <template v-slot:edit="scope">
						  <el-input @change="changeValue2" maxlength="15" v-model="scope.row.tradePrice" @blur="scope.row.tradePrice = twoDecimalPlaces2(scope.row.tradePrice)"></el-input>
					  </template>
				  </vxe-table-column>
				  <vxe-table-column min-width="80px" align="center" field="priceSum" title="商品总价" :edit-render="{}">
					  <template v-slot:edit="scope">
						  <el-input :disabled='true' v-model="scope.row.priceSum" @blur="scope.row.priceSum = twoDecimalPlaces(scope.row.priceSum)" maxlength="15"></el-input>
					  </template>
				  </vxe-table-column>
				  <vxe-table-column min-width="80px" align="center" field="actualPrice" title="实际价格" :edit-render="{}">
					  <template v-slot:edit="scope">
						  <el-input v-model="scope.row.actualPrice" @blur="scope.row.actualPrice = twoDecimalPlaces(scope.row.actualPrice)" maxlength="15"></el-input>
					  </template>
				  </vxe-table-column>

				  <vxe-table-column min-width="80px" align="center" field="remarks" title="备注" :edit-render="{}">
					  <template v-slot:edit="scope">
						  <el-input maxlength="255" v-model="scope.row.remarks" ></el-input>
					  </template>
				  </vxe-table-column>
				  <vxe-table-column align="center" fixed="right" title="操作" width="220px">
					  <template v-slot="scope">
						  <vxe-button status="primary" v-show="method === 'view'" :disabled="false" @click="seeFileInfo2(scope.$rowIndex)">查看附件</vxe-button>
						  <vxe-button status="primary" v-if="method !== 'view'" @click="sss2(scope.$rowIndex)">上传附件</vxe-button>
						  <vxe-button status="danger" v-if="method !== 'view'" @click="removeEvent(scope.row,scope.$rowIndex,'detail')">删除</vxe-button>
					  </template>
				  </vxe-table-column>
			  </vxe-table>
		  </el-col>
        </el-row>

      </el-form>
      <!-- 附件 -->
      <UpdateInfoForm ref="updateInfoForm"></UpdateInfoForm>
      <UpLoadComponent ref="uploadComponent"></UpLoadComponent>
      <MaterialManagementDialog ref="materialManagementDialog" @getUpload="getUpload"></MaterialManagementDialog>
      <CwProgramPageForm ref="cwProgramPageForm" @getProgram="getProgram"></CwProgramPageForm>
      <MaterialTypePullForm ref="materialTypePullForm" @getProgramForType="getProgramForType"></MaterialTypePullForm>
      <UserPullForm ref="userPullForm" @getProgramForUser="getProgramForUser"></UserPullForm>
      <PurchaseChooseForm  ref="purchaseChooseForm" @getProject="getContract"></PurchaseChooseForm>
<!--      合同选择-->
      <ContractChooseForm  ref="contractChooseForm" @getProject="getContract3"></ContractChooseForm>
		<template #footer>
			<span class="dialog-footer">
			  <el-button @click="close()" icon="el-icon-circle-close">关闭</el-button>
			  <el-button type="primary" v-if="method !== 'view'" @click="doSubmit()" icon="el-icon-circle-check" v-noMoreClick>确定</el-button>
			</span>
		</template>
    </el-dialog>
  </div>
</template>

<script>
  import SelectTree from '@/components/treeSelect/treeSelect.vue'
  import MaterialManagementDialog from '../file/MaterialManagementDialog'
  import CwProgramPageForm from '@/views/cw/reimbursementApproval/info/CwProgramPageForm'
  import MaterialTypePullForm from '../info/MaterialTypePullForm'
  import MaterialManagementService from '@/api/materialManagement/MaterialManagementService'
  import WareHouseService from '@/api/materialManagement/WareHouseService'
  import UpLoadComponent from '@/views/common/UpLoadComponent'
  import UserPullForm from '@/views/finance/invoice/UserPullForm'
  import PurchaseChooseForm from './PurchaseChooseForm'
  import ContractChooseForm from '../contract/ContractChooseForm'
  import XEUtils from 'xe-utils'
  import UpdateInfoForm from '../info/UpdateInfoForm'
  import SupplierService from '@/api/materialManagement/SupplierService'
  export default {
    data () {
      return {
        validRules: {
          wareHouseMan: [
            { required: true, message: '请选择入库人' }
          ],
          wareHouseType: [
            { required: true, message: '请选择入库类型' }
          ],
          supplierName: [
            { required: true, message: '请选择供应商' }
          ],
          tradeName: [
            { required: true, message: '请填写商品名称' }
          ],
          tradeNumber: [
            {required: true, message: '商品数量不能为空'}
          ]
        },
        purchaseId: '',
        title: '',
        method: '',
        visible: false,
        loading: false,
        inputForm: {
          wareHouseTotalPrice: '', // 入库商品总价
          wareHouseActualPrice: '', // 入库商品实际价格
          tradeTotalPrice: '',  // 商品总价
          fileInfoLost: [],
          purchaseNo: '',
          contractNo: '',
          handledBy: '',
          handledById: '',
          handledByOffice: '',
          wareHouseName: '',
          wareHouseNumber: '', // 入库编号
          userId: '',
          wareHouseDate: '',
          remarks: '',
          detailInfos: [],
          wareHouse: [],
          // amountInfos: [],
          files: [] // 附件信息
        },
        tableKey: '',
        loading4: false,
        tablePage4: {
          total: 0,
          currentPage: 1,
          pageSize: 10
        },
        tableColumn4: [
          { field: 'name', title: '名称', align: 'center' },
          { field: 'address', title: '地址', align: 'center' },
          { field: 'telPhone', title: '联系电话', align: 'center' }
        ],
        tableData4: [],
        suppName: '',
        suppIndex: ''
      }
    },
    MaterialManagementService: null,
    WareHouseService: null,
    supplierService: null,
    created () {
      this.materialManagementService = new MaterialManagementService()
      this.wareHouseService = new WareHouseService()
      this.supplierService = new SupplierService()
    },
    components: {
      SelectTree,
      MaterialTypePullForm,
      CwProgramPageForm,
      MaterialManagementDialog,
      UpLoadComponent,
      UserPullForm,
      PurchaseChooseForm,
      ContractChooseForm,
      UpdateInfoForm
    },
    computed: {
      name () {
        return this.$store.state.user.name
      },
      wareHouseManId () {
        return this.$store.state.user.id
      },
      wareHouseTypeId () {
        return ''
      },
      officeName () {
        return this.$store.state.user.office.name
      }
    },
    methods: {
      init (method, id) {
        this.method = method
        this.inputForm = {
          wareHouseTotalPrice: '', // 入库商品总价
          wareHouseActualPrice: '', // 入库商品实际价格
          tradeTotalPrice: '',  // 商品总价
          fileInfoLost: [],
          purchaseNo: '',
          contractNo: '',
          handledBy: this.$store.state.user.name,
          handledById: this.$store.state.user.id,
          handledByOffice: this.$store.state.user.office.id,
          wareHouseName: '',
          wareHouseNumber: '', // 入库编号
          userId: this.$store.state.user.id,
          wareHouseDate: '',
          remarks: '',
          detailInfos: [],
          wareHouse: [],
          // amountInfos: [],
          files: [] // 附件信息
        }
        if (method === 'add') {
          this.title = `新建入库信息`
        } else if (method === 'edit') {
          this.inputForm.id = id
          this.title = '修改入库信息'
        } else if (method === 'view') {
          this.inputForm.id = id
          this.title = '查看入库信息'
        } else if (method === 'purchaseAdd') {
          this.purchaseId = id
          console.log('this.purchaseId', this.purchaseId)
          this.title = `新建入库信息`
          this.getContract2(id)
        }
        this.visible = true
        this.loading = false
        this.$nextTick(() => {
          if (method === 'edit' || method === 'view') { // 修改或者查看
            this.loading = true
            this.$refs.inputForm.resetFields()
            this.wareHouseService.findById(this.inputForm.id).then((data) => {
              if (this.commonJS.isNotEmpty(data.wareHouseManId)) {
                this.wareHouseManId = data.wareHouseManId
              }
              // if (this.commonJS.isNotEmpty(data.wareHouseTypeId)) {
              //   this.wareHouseTypeId = data.wareHouseTypeId
              // }
              this.inputForm = this.recover(this.inputForm, data)
              if (this.commonJS.isEmpty(this.inputForm.handledByOffice)) {
                this.inputForm.handledByOffice = this.$store.state.user.office.id
              }
              let i = this.inputForm.detailInfos.length
              for (let j = 0; j < i; j++) {
                if (this.commonJS.isNotEmpty(this.inputForm.detailInfos[j].tradePrice)) {
                  if (this.commonJS.isNotEmpty(this.inputForm.detailInfos[j].tradeNumber)) {
                    this.inputForm.detailInfos[j].priceSum = this.inputForm.detailInfos[j].tradePrice * this.inputForm.detailInfos[j].tradeNumber
                  }
                }
              }
              let k = this.inputForm.wareHouse.length
              for (let j = 0; j < k; j++) {
                if (this.commonJS.isNotEmpty(this.inputForm.wareHouse[j].tradePrice)) {
                  if (this.commonJS.isNotEmpty(this.inputForm.wareHouse[j].tradeNumber)) {
                    this.inputForm.wareHouse[j].priceSum = this.inputForm.wareHouse[j].tradePrice * this.inputForm.wareHouse[j].tradeNumber
                  }
                }
              }
              this.$refs.uploadComponent.newUpload(method, this.inputForm.files, 'reimbursement')
              this.inputForm = JSON.parse(JSON.stringify(this.inputForm))
              this.tableKey = Math.random()
              this.loading = false
            })
          } else {
            if (method === 'add') {
              this.inputForm.wareHouseDate = new Date()
            }
            this.$refs.uploadComponent.newUpload(method, this.inputForm.files, 'reimbursement')
          }
        })
      },
      getContract (row) {
        this.materialManagementService.findById(row.id).then((data) => {
          this.inputForm.detailInfos = data.detailInfos
          this.inputForm.purchaseNo = data.purchaseNo
          let i = this.inputForm.detailInfos.length
          for (let j = 0; j < i; j++) {
            if (this.commonJS.isNotEmpty(this.inputForm.detailInfos[j].tradePrice)) {
              if (this.commonJS.isNotEmpty(this.inputForm.detailInfos[j].tradeNumber)) {
                this.inputForm.detailInfos[j].priceSum = this.inputForm.detailInfos[j].tradePrice * this.inputForm.detailInfos[j].tradeNumber
              }
            }
          }
        })
        this.$forceUpdate()
      },
      getContract2 (id) {
        this.materialManagementService.findById(id).then((data) => {
          this.inputForm.detailInfos = data.detailInfos
          this.inputForm.purchaseNo = data.purchaseNo
          let i = this.inputForm.detailInfos.length
          for (let j = 0; j < i; j++) {
            if (this.commonJS.isNotEmpty(this.inputForm.detailInfos[j].tradePrice)) {
              if (this.commonJS.isNotEmpty(this.inputForm.detailInfos[j].tradeNumber)) {
                this.inputForm.detailInfos[j].priceSum = this.inputForm.detailInfos[j].tradePrice * this.inputForm.detailInfos[j].tradeNumber
              }
            }
          }
        })
        this.$forceUpdate()
      },
      getContract3 (row) {
        console.log('row', row)
        this.inputForm.contractNo = row.contractNo
        // this.materialManagementService.findById(id).then((data) => {
        //   this.inputForm.detailInfos = data.detailInfos
        //   this.inputForm.purchaseNo = data.purchaseNo
        //   let i = this.inputForm.detailInfos.length
        //   for (let j = 0; j < i; j++) {
        //     if (this.commonJS.isNotEmpty(this.inputForm.detailInfos[j].tradePrice)) {
        //       if (this.commonJS.isNotEmpty(this.inputForm.detailInfos[j].tradeNumber)) {
        //         this.inputForm.detailInfos[j].priceSum = this.inputForm.detailInfos[j].tradePrice * this.inputForm.detailInfos[j].tradeNumber
        //       }
        //     }
        //   }
        // })
        this.$forceUpdate()
      },
      openContractForm () {
        this.$refs.purchaseChooseForm.init()
      },
      openContractChooseForm () {
        this.$refs.contractChooseForm.init()
      },
      // 值改变事件
      changeValue () {
        let i = this.inputForm.detailInfos.length
        for (let j = 0; j < i; j++) {
          if (this.commonJS.isNotEmpty(this.inputForm.detailInfos[j].tradePrice)) {
            if (this.commonJS.isNotEmpty(this.inputForm.detailInfos[j].tradeNumber)) {
              // parseFloat(item.account).toFixed(2)
              this.inputForm.detailInfos[j].priceSum = parseFloat(parseFloat(this.inputForm.detailInfos[j].tradePrice) * parseFloat(this.inputForm.detailInfos[j].tradeNumber)).toFixed(2)
            }
          }
        }
      },
      // 值改变事件
      changeValue2 () {
        let i = this.inputForm.wareHouse.length
        for (let j = 0; j < i; j++) {
          if (this.commonJS.isNotEmpty(this.inputForm.wareHouse[j].tradePrice)) {
            if (this.commonJS.isNotEmpty(this.inputForm.wareHouse[j].tradeNumber)) {
              // parseFloat(item.account).toFixed(2)
              this.inputForm.wareHouse[j].priceSum = parseFloat(parseFloat(this.inputForm.wareHouse[j].tradePrice) * parseFloat(this.inputForm.wareHouse[j].tradeNumber)).toFixed(2)
            }
          }
        }
      },
      getProgramForUser (rows) {
        // this.inputForm.detailInfos[this.indexRow].userId = rows[0].id
        // this.inputForm.detailInfos[this.indexRow].purchaser = rows[0].name
        // this.inputForm.detailInfos[this.indexRow].deptId = rows[0].parentId
        // this.inputForm.detailInfos[this.indexRow].procurementOffice = rows[0].officeName
        this.inputForm.wareHouse[this.indexRow].wareHouseManId = rows[0].id
        this.inputForm.wareHouse[this.indexRow].wareHouseMan = rows[0].name
        this.inputForm.wareHouse[this.indexRow].deptId = rows[0].parentId
        this.inputForm.wareHouse[this.indexRow].wareHouseManOffice = rows[0].officeName
        this.indexRow = ''
        this.$forceUpdate()
      },
      getProgramForType (rows) {
        this.inputForm.wareHouse[this.indexRow].wareHouseTypeId = rows.id
        this.inputForm.wareHouse[this.indexRow].wareHouseType = rows.name
        // this.inputForm.detailInfos[this.indexRow].procurementType = rows.name
        this.indexRow = ''
        this.$forceUpdate()
      },
      getProgram (rows) {
        this.inputForm.detailInfos[this.indexRow].projectId = rows[0].id
        this.inputForm.detailInfos[this.indexRow].projectName = rows[0].name
        this.inputForm.detailInfos[this.indexRow].reportNumber = rows[0].reportNo
        this.indexRow = ''
        this.$forceUpdate()
      },
      getUpload (p, index) {
        p.then((list) => {
          // list为返回数据
          this.inputForm.wareHouse[index].fileInfoLost = list
          this.inputForm.wareHouse[index].fileNumber = list.length
          this.tableKeyClient = Math.random()
        })
      },
      twoDecimalPlaces (num) {
        let str = num.toString()
        var len1 = str.substr(0, 1)
        var len2 = str.substr(1, 1)
        // eslint-disable-next-line eqeqeq
        if (str.length > 1 && len1 == 0 && len2 != '.') {
          str = str.substr(1, 1)
        }
        // eslint-disable-next-line eqeqeq
        if (len1 == '.') {
          str = ''
        }
        // eslint-disable-next-line eqeqeq
        if (str.indexOf('.') != -1) {
          var str_ = str.substr(str.indexOf('.') + 1)
          // eslint-disable-next-line eqeqeq
          if (str_.indexOf('.') != -1) {
            str = str.substr(0, str.indexOf('.') + str_.indexOf('.') + 1)
          }
          if (str_.length > 2) {
            this.$message.warning(`金额小数点后只能输入两位，请正确输入！`)
            return (str = '')
          }
        }
        // eslint-disable-next-line no-useless-escape
        str = str.replace(/[^\d^\.]+/g, '') // 保留数字和小数点
        return str
      },
      twoDecimalPlaces2 (num) {
        let str = num.toString()
        var len1 = str.substr(0, 1)
        var len2 = str.substr(1, 1)
        // eslint-disable-next-line eqeqeq
        if (str.length > 1 && len1 == 0 && len2 != '.') {
          str = str.substr(1, 1)
        }
        // eslint-disable-next-line eqeqeq
        if (len1 == '.') {
          str = ''
        }
        // eslint-disable-next-line eqeqeq
        if (str.indexOf('.') != -1) {
          var str_ = str.substr(str.indexOf('.') + 1)
          // eslint-disable-next-line eqeqeq
          if (str_.indexOf('.') != -1) {
            str = str.substr(0, str.indexOf('.') + str_.indexOf('.') + 1)
          }
          if (str_.length > 2) {
            this.$message.warning(`商品数量小数点后只能输入两位，请正确输入！`)
            return (str = '')
          }
        }
        // eslint-disable-next-line no-useless-escape
        str = str.replace(/[^\d^\.]+/g, '') // 保留数字和小数点
        return str
      },
      // 采购人下拉弹窗
      userPullListForm (rowIndex) {
        this.indexRow = rowIndex
        this.$refs.userPullForm.init()
      },
      footerMethod ({ columns, data }) {
        const footerData = [
          columns.map((column, columnIndex) => {
            if (columnIndex === 0) {
              return '商品总价'
            }
            if (['priceSum'].includes(column.property)) {
              // eslint-disable-next-line no-undef
              this.inputForm.tradeTotalPrice = XEUtils.sum(data, column.property)
              return XEUtils.sum(data, column.property)
            }
            return null
          })
        ]
        return footerData
      },
      footerMethod2 ({ columns, data }) {
        const footerData = [
          columns.map((column, columnIndex) => {
            if (columnIndex === 0) {
              return '商品总价'
            }
            if (['priceSum'].includes(column.property)) {
              // eslint-disable-next-line no-undef
              this.inputForm.wareHouseTotalPrice = XEUtils.sum(data, column.property)
              return XEUtils.sum(data, column.property)
            }
            if (['actualPrice'].includes(column.property)) {
              // eslint-disable-next-line no-undef
              this.inputForm.wareHouseActualPrice = XEUtils.sum(data, column.property)
              return XEUtils.sum(data, column.property)
            }
            return null
          })
        ]
        return footerData
      },
      seeFileInfo (index) {
        if (this.commonJS.isEmpty(this.inputForm.detailInfos[index].fileInfoLost)) {
          this.inputForm.detailInfos[index].fileInfoLost = []
        }
        this.$refs.materialManagementDialog.newUpload('view', this.inputForm.detailInfos[index].fileInfoLost, null, null, null, null, null, false, index)
      },
      sss (index) {
        if (this.commonJS.isEmpty(this.inputForm.detailInfos[index].fileInfoLost)) {
          this.inputForm.detailInfos[index].fileInfoLost = []
        }
        this.$refs.materialManagementDialog.newUpload(null, this.inputForm.wareHouse[index].fileInfoLost, null, null, null, null, null, false, index)
      },
      seeFileInfo2 (index) {
        if (this.commonJS.isEmpty(this.inputForm.wareHouse[index].fileInfoLost)) {
          this.inputForm.wareHouse[index].fileInfoLost = []
        }
        this.$refs.materialManagementDialog.newUpload('view', this.inputForm.wareHouse[index].fileInfoLost, null, null, null, null, null, false, index)
	  },
      sss2 (index) {
        if (this.commonJS.isEmpty(this.inputForm.wareHouse[index].fileInfoLost)) {
          this.inputForm.wareHouse[index].fileInfoLost = []
        }
        this.$refs.materialManagementDialog.newUpload(null, this.inputForm.wareHouse[index].fileInfoLost, null, null, null, null, null, false, index)
      },
      // 采购类型下拉弹窗
      typePullForm (rowIndex) {
        this.indexRow = rowIndex
        this.$refs.materialTypePullForm.init()
      },
      // 表单提交
      doSubmit () {
        this.$refs['inputForm'].validate((valid) => {
          if (valid) {
            this.loading = true
            if (this.$refs.uploadComponent.checkProgress()) {
              this.loading = false
              return
            }
            if (this.commonJS.isEmpty(this.inputForm.files)) {
              this.loading = false
              this.inputForm.files = []
            }
            if (this.commonJS.isEmpty(this.inputForm.wareHouse)) {
              this.$message.error('至少填写一条入库详情信息')
              this.loading = false
              return
            } else {
              let i = this.inputForm.wareHouse.length
              for (let j = 0; j < i; j++) {
                let k = j + 1
                if (this.commonJS.isEmpty(this.inputForm.wareHouse[j].wareHouseMan)) {
                  this.$message.error('入库详情第' + k + '行请选择入库人')
                  this.loading = false
                  return
                }
                if (this.commonJS.isEmpty(this.inputForm.wareHouse[j].wareHouseType)) {
                  this.$message.error('入库详情第' + k + '行请选择入库类型')
                  this.loading = false
                  return
                }
                if (this.commonJS.isEmpty(this.inputForm.wareHouse[j].supplierName) || this.commonJS.isEmpty(this.inputForm.wareHouse[j].supplierId)) {
                  this.$message.error('入库详情第' + k + '行请选择供应商')
                  this.loading = false
                  return
                }
                if (this.commonJS.isEmpty(this.inputForm.wareHouse[j].tradeName)) {
                  this.$message.error('入库详情第' + k + '行请填写商品名称')
                  this.loading = false
                  return
                }
                if (this.commonJS.isEmpty(this.inputForm.wareHouse[j].tradeNumber)) {
                  this.$message.error('入库详情第' + k + '行请填写商品数量')
                  this.loading = false
                  this.inputForm.functionFlag = ''
                  return
                }
              }
              for (let j = 0; j < i; j++) {
                for (let k = j + 1; k < i; k++) {
                  if (this.inputForm.wareHouse[j].wareHouseTypeId === this.inputForm.wareHouse[k].wareHouseTypeId) { // 如果入库类型相同
                    if (this.inputForm.wareHouse[j].tradeName === this.inputForm.wareHouse[k].tradeName) { // 如果商品名称相同
                      // 这里直接通过判断供应商的id是否相等，因为入库只允许选择供应商，不允许手填
                      if (this.inputForm.wareHouse[j].supplierId === this.inputForm.wareHouse[k].supplierId) {
                        this.$message.warning(`入库详情中，同种入库类型、同一供应商的商品名称只能输入一条`)
                        this.loading = false
                        throw new Error('入库详情中，同种入库类型、同一供应商的商品名称只能输入一条')
                      }
                    }
                  }
                }
              }
            }
            this.inputForm.files = this.$refs.uploadComponent.getDataList()
            this.wareHouseService.save(this.inputForm).then((data) => {
              // eslint-disable-next-line no-undef
              // callback(data.businessTable, data.businessId, this.inputForm)
              // this.$refs.inputForm.resetFields()
              this.$emit('refreshList')
              this.loading = false
              this.close()
            }).catch(() => {
              // this.$refs.inputForm.resetFields()
              this.loading = false
              // this.close()
            })
          }
        })
      },
      close () {
        this.inputForm.detailInfos = []
        this.inputForm.wareHouse = []
        this.inputForm.amountInfos = []
        this.$refs.uploadComponent.clearUpload()
        this.$refs.inputForm.resetFields()
        this.visible = false
      },
      // 删除
      removeEvent (row, rowIndex, type) {
        if (type === 'detail') {
          this.$refs.detailTableWare.remove(row)
          // this.inputForm.detailInfos.splice(rowIndex, 1)
          this.inputForm.wareHouse.splice(rowIndex, 1)
        }
        if (type === 'amount') {
          this.$refs.amountTable.remove(row)
          this.inputForm.amountInfos.splice(rowIndex, 1)
        }
      },
      // 新增
      async insertEvent (type) {
        if (type === 'detail') {
          await this.$refs.detailTableWare.insert().then((data) => {
            data.wareHouseManId = this.wareHouseManId
            data.wareHouseMan = this.name
            data.wareHouseManOffice = this.officeName
            // this.inputForm.detailInfos.push(data)
            this.inputForm.wareHouse.push(data)
			  this.tableKey = Math.random()
          })
        }
        if (type === 'amount') {
          await this.$refs.amountTable.insert().then((data) => {
            this.inputForm.amountInfos.push(data)
			  this.tableKey = Math.random()
          })
        }
      },
      // 查看采购详情
      async viewContract (purchaseNo) {
        this.wareHouseService.findRequestId(purchaseNo).then((data) => {
          this.$refs.updateInfoForm.init('view', data)
        }).catch(() => {
        })
      },
      ifSameValue () {
        let i = this.inputForm.wareHouse.length
        for (let j = 0; j < i; j++) {
          for (let k = j + 1; k < i; k++) {
            if (this.inputForm.wareHouse[j].wareHouseTypeId === this.inputForm.wareHouse[k].wareHouseTypeId) {
              if (this.commonJS.isNotEmpty(this.inputForm.wareHouse[j].tradeName) &&
                this.commonJS.isNotEmpty(this.inputForm.wareHouse[k].tradeName) && this.inputForm.wareHouse[j].tradeName === this.inputForm.wareHouse[k].tradeName) {
                // parseFloat(item.account).toFixed(2)
                this.inputForm.wareHouse.splice(k, 1)
                this.$message.warning(`同种入库类型的商品名称只能输入一条信息！`)
              }
            }
          }
        }
      },
      wareHouseAdd (index) {
      //  将采购详情中的采购类型，商品名称，商品数量，商品单价，商品总结，带到入库详情中
        // eslint-disable-next-line no-unused-vars
        let param = {
          wareHouseMan: this.name,
          wareHouseManId: this.wareHouseManId,
          wareHouseManOffice: this.officeName,
          wareHouseTypeId: this.inputForm.detailInfos[index].procurementTypeId,
          wareHouseType: this.inputForm.detailInfos[index].procurementType,
          tradeName: this.inputForm.detailInfos[index].tradeName,
          tradeNumber: this.inputForm.detailInfos[index].tradeNumber,
          tradePrice: this.inputForm.detailInfos[index].tradePrice,
          company: this.inputForm.detailInfos[index].company,
          priceSum: this.inputForm.detailInfos[index].priceSum,
          supplierId: '',
          supplierName: '',
          isSupplier: ''
        }
        if (this.commonJS.isNotEmpty(this.inputForm.detailInfos[index].supplierId) &&
          this.commonJS.isNotEmpty(this.inputForm.detailInfos[index].isSupplier) &&
          this.inputForm.detailInfos[index].isSupplier === '2'
        ) {
          param.supplierId = this.inputForm.detailInfos[index].supplierId
          param.supplierName = this.inputForm.detailInfos[index].supplierName
          param.isSupplier = this.inputForm.detailInfos[index].isSupplier
        }
        this.inputForm.wareHouse.push(param)
		  this.tableKey = Math.random()
      },
      focusEvent4 (rowIndex) {
        this.$refs.xDown4.showPanel()
        this.loading4 = true
        this.suppName = '' // 搜索框的值 清空
        this.suppIndex = rowIndex // 获取当前行下标
        this.tablePage4.currentPage = 1
        this.tablePage4.pageSize = 10
        this.refreshSupplierList()
      },
      suffixClick4 () {
        this.$refs.xDown4.togglePanel()
      },
      searchClick () {
        this.refreshSupplierList()
      },
      cellClickEvent4 ({ row }) {
        this.inputForm.wareHouse[this.suppIndex].supplierName = row.name
        this.inputForm.wareHouse[this.suppIndex].supplierId = row.id
        this.inputForm.wareHouse[this.suppIndex].isSupplier = '2' // isSupplier：手动填写 ‘1’ 选择填写 ‘2’
        this.suppIndex = ''
        this.$refs.xDown4.hidePanel()
      },
      pageChangeEvent4 ({ currentPage, pageSize }) {
        this.tablePage4.currentPage = currentPage
        this.tablePage4.pageSize = pageSize
        this.refreshSupplierList()
      },
      // 刷新供应商
      refreshSupplierList () {
        this.supplierService.list({
          'current': this.tablePage4.currentPage,
          'size': this.tablePage4.pageSize,
          'name': this.suppName
        }).then((data) => {
          this.tableData4 = data.records
          this.tablePage4.total = data.total
          this.loading4 = false
        })
      },
      focusEvent1 (row) {
        row.tradeNameList = []
        row.tradeNameData = []
        if (this.commonJS.isNotEmpty(row.wareHouseTypeId)) {
          this.wareHouseService.findTradeByTypeId(row.wareHouseTypeId).then((data) => {
            row.tradeNameList = JSON.parse(JSON.stringify(data))
            row.tradeNameData = JSON.parse(JSON.stringify(data))
            this.$refs.xDown1.showPanel()
          }).catch(() => {
            this.$refs.xDown1.showPanel()
          })
        } else {
          this.$refs.xDown1.showPanel()
        }
      },
      keyupEvent1 (row) {
        row.tradeNameData = this.commonJS.isNotEmpty(row.tradeName) ? row.tradeNameList.filter(item => item.tradeName.indexOf(row.tradeName) > -1) : row.tradeNameList
      },
      selectEvent1 (row, item) {
        row.tradeName = item.tradeName
        this.$refs.xDown1.hidePanel()
      }
    }
  }
</script>
<style scoped>
  .el-divider__text {
    font-size: 16px;
    font-weight: bold;
  }
  .vxe-pulldown--panel {
    z-index: 9997 !important
  }

  /*.my-dropdown1、.list-item1、.list-item1:hover  为商品名称下拉选择框样式*/
  .my-dropdown1 {
    height: 155px;
    overflow: auto;
    border-radius: 4px;
    border: 1px solid #dcdfe6;
    background-color: #fff;
  }
  .list-item1 {
    line-height: 30px;
    text-align: center;
    border-bottom: #c4c7cc73 1px solid;
  }
  .list-item1:hover {
    background-color: #f5f7fa;
  }
</style>
